# GP toolbox

Blender addon - Various tool to help with grease pencil in animation productions.

**[Download latest](https://gitlab.com/autour-de-minuit/blender/gp_toolbox/-/archive/master/gp_toolbox-master.zip)**

**[Demo video](https://www.youtube.com/watch?v=Htgao_uPWNs)**

**[Readme Doc in French (Documentation en Français et plus détaillée)](README_FR.md)**

---  

## Description

<!-- ![pseudo color demo](https://github.com/Pullusb/images_repo/blob/master/GPT_pseudo_tint.gif)
*In this demo F9 is pressed to call the "redo panel" and modify the hue offset with constant update*   -->
  
In sidebar (N) > Gpencil > Toolbox

<!-- - Pseudo tint color : Tints each GP layer of selected GP objects with a pseudo random tints to quickly identify which lines belong to which layer.  
/!\ Using this will override the tint and tint factor on your layer (so they will be lost if you used it for a specific layer) -->

## Addon preferences

important point of addon preferences:  

Set path to the palette folder (there is a json palette IO but you an also put a blend and use a blend importer)

Note about palette : For now the importer is not working with linked palette as it's not easy for animator (there are properties of the material you cannot access and the link grey-out fade the real color in UIlist preview)


### Passive action

Add an "on save" Handler that trigger relative remap of all path (can be disabled in addon prefs).

### function

- Mirror flip : If in cam view flip the camera X scale value (you can see and draw mnirrored to see problems)

<!-- - Overlay toggle : (toggle pref and overlay)  -->

- quick access to scene camera passepartout toggle and opacity

- quick access to scene camera background images visibility with individual references toggle.

- Basic playblast and viewport playblast:

  - dedicated resolution percentage value

  - can auto launch and/or auto open folder at finished (option in addon preferences)

- Jump to GP keyframe :

  - Choose key to Auto bind in addon prefs (since 0.9.3).  
  > Manual setup: Add two keymap shortcut in _windows_ or _screen(global)_ with indentifier `screen.gp_keyframe_jump`, one should have `next` toggled off to jump back

- GP paint cutter tool temporary switch shortcut
  - Map manually to a key with `wm.temp_cutter` (This one needs "Any" as press mode) or `wm.sticky_cutter` (Modal sticky-key version)

- Snap cursor to GP canvas operator accessible with `view3d.cusor_snap` 
  - Map nanually (might be autoreplaced according to version) by replacing entry using `view3d.cursor3d` in 3D View category (defaut shortcut `Shift + Right-clic`)

- Follow cursor toggle : When activated the cursor follow the active the active object

- [breakdowner operator for object mode](https://blenderartists.org/t/pose-mode-animation-tools-for-object-mode/1221322), auto-keymap on : Shift + E 

- Line extender help closing gaps between lines with control over layer target (-> need also control over frame targets)

- GP copy paste : world space cut-copy-paste (bake strokes). `Ctrl + Shift + X/C/V`
Store strokes in os'clipboard (easier cross blend copy)
cutting is use a more user friendly  (leave boundary points of left strokes untouched).  
Also Possible to copy whole selected layers.

- Auto update : you have an updater in the addon preference tabs (use the [CGcookie addon updater](https://github.com/CGCookie/blender-addon-updater))


**Palette management**

In material submenu you have mutliple new entry:

- Copy Materials To Selected : copy all material to other selected GP (difference with Ctrl+L > materials is that it doesn't erase materials, only append those that are not in other's materials stack)

- Load/Save Json palette : Save/load materials externally to a json file from/to the active material stack.

- Load Color palette : same as the load above exept it loads directly from a blend file (all the material that the blend contains)

### Where ?

Panel in sidebar : 3D view > sidebar 'N' > Gpencil

<!--
## Todo:

- Allow to render resolution from cam name

- Update multi output system:
    - use render layers + file outputs instead of batch by tweaking visibility

- BG Playblast enhancement:
    - Add a prefs to fallback to "simple" render.

- Settings-io for projects : Rsolution du film, palette folder, render settings...

- expose "tool setting" of canvas handling in sidebar (visible only in draw mode)

- Move automatically view to match GP Front (depending on Gpencil view settings)

- move GP keyframes selection and Object keyframe selection simultaneouly (Already Done by Tom Viguier at [Andarta](https://gitlab.com/andarta-pictures)  -->


---

Consult [Changelog here](CHANGELOG.md)